**    ModelEco : MODELisation en programmation mathmatique pour l'analyse ECOnomique de l'agriculure    **

*-----------------------------------------------------------------------------*
$Ontext
Nom              rotation1.gms
Sequence         2 - Le modle d'exploitation agricole
Type             LP
Langage GAMS     SUBSET
Description

Source : rseau INOSYS des chambres d'agriculture de la rgion Centre Val de Loire

Un agriculteur du Centre-Val de Loire en grandes cultures ave cultures spciales dispose de 110 ha de terre.
En partie grce  l'environnement conomique il a le choix entre un grand ventail de productions possibles :
bl tendre, bl dur, orge de printemps, pommes de terre de consommation, betteraves et orge.
Cinq de ses cultures sont irrigues pour permettre une production rgulire de qualit.
Les besoins en irrigation et les donnes conomiques sont donnes dans les tableaux ci-dessous :

Irrigation
Cultures         Vol en m3/ha
Bl tendre       175
Bl dur          350
Orge de print    700
Pdt conso        1800
Betteraves       1750

Situation technico-conomiques
Cultures         Rendements (qx/ha)      Prix/qx ()     Charges totales (/ha)
Bl tendre       85                      16              460
Bl dur          71                      28              565
Orge de print    70                      17.5            470
Pdt conso.       495                     14              4210
Betteraves       950                     2.6             1082
Colza            40                      38              490

Pour des raisons agronomiques, les olagineux ne peuvent pas revenir plus d'une anne sur trois sur la mme parcelle,
les crales ne peuvent pas tre cultives plus de deux ans de suite et
les betteraves et les pommes de terre ensemble ne peuvent pas revenir plus d'une anne sur six sur la mme parcelle. "



$Offtext


*----------                          INDICES                        ----------*
sets
C cultures       /bleT, bleD, bett, colza, pdt, orge/
Olea(C)          /colza/
Cere(C)          /bleT, bleD, orge/
BP(C)            /bett, pdt/
;

*----------                          DONNEES                        ----------*
scalar
DTERRE disponibilite de terre en hectares        /110/
DEAU   disponibilite en eau                      /60000/

duree  dure de la rotation                      /6/
maxOlea nombre d'anne maximum pour les olagineux /2/
maxCere nombre d'anne maximum pour les crales   /4/
maxBP  nombre d'anne maximum pour les betteraves et les pommes de terre /1/
;


parameter BEAU(C) besoins en eau par culture et technique (m3 par ha)
/bleT    175
 bleD    350
 bett   1750
 colza     0
 pdt    1800
 orge    700/
;

parameter
RDT (C) rendement par culture en quintaux par ha
/bleT     85
 bleD     71
 bett    950
 colza    40
 pdt     495
 orge     70/
;

parameter
PX (C) prix de vente par culture en euros
/bleT    16
 bleD    28
 bett     2.6
 colza   38
 pdt     14
 orge    17.5/
;

parameter
COUT (C) cout variable par culture en euros par ha
/bleT    460
 bleD    565
 bett   1082
 colza   490
 pdt    4210
 orge    470/
;

parameter
MB(C) marge brute par culture en euros    ;
MB(C) = RDT(C)*PX(C)-COUT(C);

display MB ;
*----------                         MODELE                          ----------*
variables
Z    revenu total de l exploitation (euros)
;

positive variables
X     superficie par culture (hectares)
;

equations
   OBJECTIF       fonction objectif
   TERRE          contrainte de terre
   EAU            contrainte d'irrigation
   Rot_Olea
   Rot_Cere
   Rot_BP
;

OBJECTIF..       sum (C, MB(C)* X(C)) =E= Z ;

TERRE..          sum(C, X(C)) =l= dterre  ;

EAU..            sum(C, BEAU(C)*X(C)) =l= deau  ;

Rot_Olea..       sum(olea, X(olea)) =l= sum(C, X(C))* maxOlea /duree ;

Rot_Cere..       sum(cere, X(cere)) =l= sum(C, X(C))*maxCere/duree ;

Rot_BP..         sum(BP, X(BP)) =l= sum(C, X(C))*maxBP/duree ;


model modelS2 premier exemple /all/;

*----------                        SOLUTION                         ----------*
solve modelS2 using LP maximizing Z;





